]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
IPFire-Seeder gebaut...
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 #ipfiremake linux XEN=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake klibc
353 ipfiremake mkinitcpio
354 ipfiremake udev KLIBC=1
355 ipfiremake expat
356 ipfiremake gdbm
357 ipfiremake gmp
358 ipfiremake pam
359 ipfiremake openssl
360 ipfiremake curl
361 ipfiremake python
362 ipfiremake libnet
363 ipfiremake libjpeg
364 ipfiremake libpng
365 ipfiremake libtiff
366 ipfiremake libart
367 ipfiremake freetype
368 ipfiremake gd
369 ipfiremake popt
370 ipfiremake pcre
371 ipfiremake slang
372 ipfiremake newt
373 ipfiremake libcap
374 ipfiremake pciutils
375 ipfiremake usbutils
376 ipfiremake libxml2
377 ipfiremake libxslt
378 ipfiremake BerkeleyDB
379 ipfiremake mysql
380 ipfiremake cyrus-sasl
381 ipfiremake openldap
382 ipfiremake apache2
383 ipfiremake php
384 ipfiremake apache2 PASS=C
385 ipfiremake arping
386 ipfiremake beep
387 ipfiremake bind
388 ipfiremake capi4k-utils
389 ipfiremake cdrtools
390 ipfiremake dnsmasq
391 ipfiremake dosfstools
392 ipfiremake reiserfsprogs
393 ipfiremake squashfstools
394 ipfiremake sysfsutils
395 ipfiremake ntfs-3g
396 ipfiremake ethtool
397 ipfiremake ez-ipupdate
398 ipfiremake fcron
399 ipfiremake GD
400 ipfiremake GD-Graph
401 ipfiremake GD-TextUtil
402 ipfiremake gnupg
403 ipfiremake hdparm
404 ipfiremake ibod
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipp2p IPT=1
410 ipfiremake moblock
411 ipfiremake linux-igd
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isdn4k-utils
418 ipfiremake mISDN
419 ipfiremake hwdata
420 ipfiremake kudzu
421 ipfiremake logrotate
422 ipfiremake logwatch
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nasm
427 ipfiremake URI
428 ipfiremake HTML-Tagset
429 ipfiremake HTML-Parser
430 ipfiremake Compress-Zlib
431 ipfiremake Digest
432 ipfiremake Digest-SHA1
433 ipfiremake Digest-HMAC
434 ipfiremake libwww-perl
435 ipfiremake Net-DNS
436 ipfiremake Net-IPv4Addr
437 ipfiremake Net_SSLeay
438 ipfiremake IO-Stringy
439 ipfiremake Unix-Syslog
440 ipfiremake Mail-Tools
441 ipfiremake MIME-Tools
442 ipfiremake Net-Server
443 ipfiremake Convert-TNEF
444 ipfiremake Convert-UUlib
445 ipfiremake Archive-Tar
446 ipfiremake Archive-Zip
447 ipfiremake Text-Tabs+Wrap
448 ipfiremake Locale-Country
449 ipfiremake XML-Parser
450 ipfiremake MP3-Info
451 ipfiremake MP3-Tag
452 ipfiremake glib
453 ipfiremake GeoIP
454 ipfiremake fwhits
455 ipfiremake noip_updater
456 ipfiremake ntp
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake snortsnarf
465 ipfiremake oinkmaster
466 ipfiremake squid
467 ipfiremake squid-graph
468 ipfiremake squidguard
469 ipfiremake calamaris
470 ipfiremake tcpdump
471 ipfiremake traceroute
472 ipfiremake vlan
473 ipfiremake wireless
474 ipfiremake libsafe
475 ipfiremake 3c5x9setup
476 ipfiremake pakfire
477 ipfiremake java
478 ipfiremake spandsp
479 ipfiremake lzo
480 ipfiremake openvpn
481 ipfiremake pammysql
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake bridge-utils
489 ipfiremake screen
490 ipfiremake hddtemp
491 ipfiremake smartmontools
492 ipfiremake htop
493 ipfiremake postfix
494 ipfiremake fetchmail
495 ipfiremake cyrusimap
496 ipfiremake webcyradm
497 ipfiremake mailx
498 ipfiremake clamav
499 ipfiremake spamassassin
500 ipfiremake amavisd
501 ipfiremake stund
502 ipfiremake libpri
503 # ipfiremake bristuff
504 ipfiremake asterisk
505 ipfiremake mpg123
506 ipfiremake mpfire
507 ipfiremake libmad
508 ipfiremake libogg
509 ipfiremake libvorbis
510 ipfiremake lame
511 ipfiremake sox
512 ipfiremake gnump3d
513 ipfiremake libsigc++
514 ipfiremake applejuice
515 ipfiremake ocaml
516 ipfiremake mldonkey
517 ipfiremake libtorrent
518 ipfiremake rtorrent
519 ipfiremake ipfireseeder
520 ipfiremake rsync
521 ipfiremake tcpwrapper
522 ipfiremake portmap
523 ipfiremake nfs
524 ipfiremake nmap
525 ipfiremake mbmon
526 ipfiremake iftop
527 ipfiremake ncftp
528 ipfiremake cftp
529 ipfiremake etherwake
530 ipfiremake ethereal
531 ipfiremake tftp-hpa
532 ipfiremake bwm-ng
533 ipfiremake tripwire
534 ipfiremake sysstat
535 ipfiremake vsftpd
536 ipfiremake alsa
537 ipfiremake mp3blaster
538 ipfiremake which
539 ipfiremake lsof
540 }
541
542 buildinstaller() {
543 # Run installer scripts one by one
544 LOGFILE="$BASEDIR/log/_build.installer.log"
545 export LOGFILE
546 ipfiremake syslinux
547 ipfiremake as86
548 ipfiremake mbr
549 ipfiremake memtest
550 installmake linux-libc-header
551 installmake binutils
552 ipfiremake uClibc PASS=1
553 ipfiremake gcc INST=1
554 installmake uClibc PASS=2
555 installmake gcc INST=2
556 installmake uClibc PASS=3
557 installmake busybox
558 installmake udev
559 installmake slang
560 installmake newt
561 installmake gettext
562 installmake kbd
563 installmake popt
564 installmake sysvinit
565 installmake misc-progs
566 installmake e2fsprogs
567 installmake libaal
568 installmake reiser4progs
569 installmake reiserfsprogs
570 installmake sysfsutils
571 installmake util-linux
572 installmake pciutils
573 installmake zlib
574 installmake mtd
575 installmake wget
576 installmake hwdata
577 installmake kudzu
578 installmake installer
579 installmake initrd
580 }
581
582 buildpackages() {
583 LOGFILE="$BASEDIR/log/_build.packages.log"
584 export LOGFILE
585 echo "... see detailed log in _build.*.log files" >> $LOGFILE
586
587 installmake strip
588
589 # Generating list of packages used
590 echo -n "Generating packages list from logs" | tee -a $LOGFILE
591 rm -f $BASEDIR/doc/packages-list
592 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
593 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
594 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
595 fi
596 done
597 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
598 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
599 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
600 rm -f $BASEDIR/doc/packages-list
601 # packages-list.txt is ready to be displayed for wiki page
602 beautify message DONE
603
604 # Create images for install
605 if [ "$DEVEL" == "1" ]; then
606 ipfiremake cdrom ED=devel
607 fi
608 ipfiremake cdrom ED=full
609
610 # Check if there is a loop device for building in virtual environments
611 if [ -e /dev/loop0 ]; then
612 ipfiremake usb-stick
613 fi
614 ipfiremake pxe
615 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
616
617 ipfirepackages
618
619 # Cleanup
620 stdumount
621 rm -rf $BASEDIR/build/tmp/*
622
623 # Generating total list of files
624 echo -n "Generating files list from logs" | tee -a $LOGFILE
625 rm -f $BASEDIR/log/FILES
626 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
627 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
628 echo "##" >>$BASEDIR/log/FILES
629 echo "## `basename $i`" >>$BASEDIR/log/FILES
630 echo "##" >>$BASEDIR/log/FILES
631 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
632 fi
633 done
634 beautify message DONE
635
636 cd $PWD
637 }
638
639 ipfirepackages() {
640 ipfiredist alsa
641 # ipfiredist amavisd
642 ipfiredist applejuice
643 # ipfiredist asterisk
644 ipfiredist clamav
645 ipfiredist cups
646 ipfiredist cyrus-sasl
647 # ipfiredist fetchmail
648 # ipfiredist gnump3d
649 ipfiredist ipfireseeder
650 ipfiredist java
651 ipfiredist libogg
652 ipfiredist libvorbis
653 # ipfiredist mailx
654 # ipfiredist mldonkey
655 ipfiredist mp3blaster
656 ipfiredist mpfire
657 ipfiredist mpg123
658 # ipfiredist nfs
659 ipfiredist openldap
660 # ipfiredist postfix
661 ipfiredist rtorrent
662 ipfiredist samba
663 # ipfiredist sox
664 # ipfiredist spamassassin
665 ipfiredist tripwire
666 ipfiredist vsftpd
667 # ipfiredist webcyradm
668 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
669 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
670 rm -rf $BASEDIR/build/install/packages/*
671 }
672
673 # See what we're supposed to do
674 case "$1" in
675 build)
676 clear
677 BUILDMACHINE=`uname -m`
678 DEVEL=0
679 if [ "$2" == "--devel" ]; then
680 DEVEL=1
681 fi
682 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
683 #only restore on a clean disk
684 if [ ! -f log/cleanup-toolchain-2-tools ]; then
685 if [ ! -n "$PACKAGE" ]; then
686 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
687 prepareenv
688 buildtoolchain
689 else
690 PACKAGENAME=${PACKAGE%.tar.gz}
691 beautify build_stage "Packaged toolchain compilation"
692 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
693 tar zxf $PACKAGE
694 prepareenv
695 else
696 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
697 fi
698 fi
699 else
700 echo -n "Using installed toolchain" | tee -a $LOGFILE
701 beautify message SKIP
702 prepareenv
703 fi
704
705 beautify build_start
706 beautify build_stage "Building LFS"
707 buildbase
708
709 beautify build_stage "Building IPFire"
710 buildipfire
711
712 # Setzen des IPFire Builds
713 if [ "$FIREBUILD" ]; then
714 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
715 else
716 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
717 fi
718
719 beautify build_stage "Building installer"
720 buildinstaller
721
722 beautify build_stage "Building packages"
723 buildpackages
724 beautify build_end
725 ;;
726 shell)
727 # enter a shell inside LFS chroot
728 # may be used to changed kernel settings
729 prepareenv
730 entershell
731 ;;
732 changelog)
733 echo -n "Loading new Changelog from SVN: "
734 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
735 beautify message DONE
736 ;;
737 clean)
738 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
739 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
740 $LOSETUP -d $i 2>/dev/null
741 done
742 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
743 umount $i
744 done
745 stdumount
746 for i in `seq 0 7`; do
747 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
748 umount /dev/loop${i} 2>/dev/null;
749 losetup -d /dev/loop${i} 2>/dev/null;
750 fi;
751 done
752 rm -rf $BASEDIR/build
753 rm -rf $BASEDIR/cdrom
754 rm -rf $BASEDIR/packages
755 rm -rf $BASEDIR/log
756 if [ -h /tools ]; then
757 rm -f /tools
758 fi
759 beautify message DONE
760 ;;
761 downloadsrc)
762 if [ ! -d $BASEDIR/cache ]; then
763 mkdir $BASEDIR/cache
764 fi
765 mkdir -p $BASEDIR/log
766 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
767 FINISHED=0
768 cd $BASEDIR/lfs
769 for c in `seq $MAX_RETRIES`; do
770 if (( FINISHED==1 )); then
771 break
772 fi
773 FINISHED=1
774 cd $BASEDIR/lfs
775 for i in *; do
776 if [ -f "$i" -a "$i" != "Config" ]; then
777 echo -ne "Loading $i"
778 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
779 if [ $? -ne 0 ]; then
780 beautify message FAIL
781 FINISHED=0
782 else
783 if [ $c -eq 1 ]; then
784 beautify message DONE
785 fi
786 fi
787 fi
788 done
789 done
790 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
791 ERROR=0
792 for i in *; do
793 if [ -f "$i" -a "$i" != "Config" ]; then
794 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
795 if [ $? -ne 0 ]; then
796 echo -ne "MD5 difference in lfs/$i"
797 beautify message FAIL
798 ERROR=1
799 fi
800 fi
801 done
802 if [ $ERROR -eq 0 ]; then
803 echo -ne "${BOLD}all files md5sum match${NORMAL}"
804 beautify message DONE
805 else
806 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
807 beautify message FAIL
808 fi
809 cd - >/dev/null 2>&1
810 ;;
811 toolchain)
812 clear
813 prepareenv
814 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
815 buildtoolchain
816 BUILDMACHINE=`uname -m`
817 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
818 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
819 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
820 build/{bin,etc,usr/bin,usr/local} \
821 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
822 log >> $LOGFILE
823 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
824 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
825 stdumount
826 ;;
827 gettoolchain)
828 BUILDMACHINE=`uname -m`
829 # arbitrary name to be updated in case of new toolchain package upload
830 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
831 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
832 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
833 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
834 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
835 cd $BASEDIR/cache/toolchains
836 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
837 if [ $? -ne 0 ]; then
838 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
839 else
840 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
841 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
842 else
843 exiterror "$PACKAGE.md5 did not match, check downloaded package"
844 fi
845 fi
846 else
847 echo "Toolchain is already downloaded. Exiting..."
848 fi
849 ;;
850 othersrc)
851 prepareenv
852 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
853 chroot $LFS /tools/bin/env -i HOME=/root \
854 TERM=$TERM PS1='\u:\w\$ ' \
855 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
856 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
857 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
858 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
859 if [ $? -eq "0" ]; then
860 beautify message DONE
861 else
862 beautify message FAIL
863 fi
864 stdumount
865 ;;
866 svn)
867 case "$2" in
868 update|up)
869 # clear
870 echo -ne "Loading the latest source files...\n"
871 if [ $3 ]; then
872 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
873 else
874 svn update | tee -a $PWD/log/_build.svn.update.log
875 fi
876 if [ $? -eq "0" ]; then
877 beautify message DONE
878 else
879 beautify message FAIL
880 exit 1
881 fi
882 echo -ne "Writing the svn-info to a file"
883 svn info > $PWD/svn_status
884 if [ $? -eq "0" ]; then
885 beautify message DONE
886 else
887 beautify message FAIL
888 exit 1
889 fi
890 chmod 755 $0
891 exit 0
892 ;;
893 commit|ci)
894 clear
895 if [ -f /usr/bin/mcedit ]; then
896 export EDITOR=/usr/bin/mcedit
897 fi
898 if [ -f /usr/bin/nano ]; then
899 export EDITOR=/usr/bin/nano
900 fi
901 echo -ne "Selecting editor $EDITOR..."
902 beautify message DONE
903 if [ -e /sbin/yast ]; then
904 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
905 $0 changelog
906 fi
907 fi
908 update_langs
909 svn commit
910 $0 svn up
911 if [ -n "$FTP_CACHE_URL" ]; then
912 $0 uploadsrc
913 fi
914 ;;
915 dist)
916 if [ $3 ]; then
917 SVN_REVISION=$3
918 fi
919 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
920 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
921 exit 0
922 fi
923 echo -en "REV $SVN_REVISION: Downloading..."
924 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
925 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
926 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
927 evaluate 1
928
929 echo -en "REV $SVN_REVISION: Compressing files..."
930 if [ -e ipfire-source/trunk/make.sh ]; then
931 chmod 755 ipfire-source/trunk/make.sh
932 fi
933 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
934 evaluate 1
935 echo -en "REV $SVN_REVISION: Cleaning up..."
936 rm ipfire-source/ -r
937 evaluate 1
938 ;;
939 diff|di)
940 update_langs
941 echo -ne "Make a local diff to last svn revision"
942 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
943 evaluate 1
944 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
945 svn status
946 ;;
947 esac
948 ;;
949 uploadsrc)
950 PWD=`pwd`
951 cd $BASEDIR/cache/
952 echo -e "Uploading cache to ftp server:"
953 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
954 for i in *; do
955 if [ "$i" == "toolchains" ]; then continue; fi
956 grep -q $i /tmp/ftplist
957 if [ "$?" -ne "0" ]; then
958 echo -ne "$i"
959 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
960 if [ "$?" -ne "0" ]; then
961 beautify message FAIL
962 fi
963 fi
964 done
965 rm -f /tmp/ftplist
966 cd $PWD
967 exit 0
968 ;;
969 upload)
970 case "$2" in
971 iso)
972 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
973 cat <<EOF > .ftp-commands
974 mkdir -p $FTP_ISO_PATH$SVN_REVISION
975 ls -lah
976 quit
977 EOF
978 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
979 rm -f .ftp-commands
980 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
982 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
983 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
984 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
985 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
986 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
987 fi
988 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
989 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
990 if [ "$?" -eq "0" ]; then
991 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
992 else
993 echo -e "There was an error while uploading the iso to the ftp server."
994 exit 1
995 fi
996 if [ "$3" = "--with-sources-cd" ]; then
997 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
998 fi
999 ;;
1000 paks)
1001 cat <<EOF > .ftp-commands
1002 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
1003 ls -lah
1004 quit
1005 EOF
1006 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
1007 rm -f .ftp-commands
1008 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1009 if [ "$?" -eq "0" ]; then
1010 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1011 else
1012 echo -e "There was an error while uploading the packages to the ftp server."
1013 exit 1
1014 fi
1015 ;;
1016 esac
1017 ;;
1018 batch)
1019 if [ "$2" = "--background" ]; then
1020 batch_script
1021 exit $?
1022 fi
1023 if [ `screen -ls | grep -q ipfire` ]; then
1024 echo "Build is already running, sorry!"
1025 exit 1
1026 else
1027 if [ "$2" = "--rebuild" ]; then
1028 export IPFIRE_REBUILD=1
1029 echo "REBUILD!"
1030 else
1031 export IPFIRE_REBUILD=0
1032 fi
1033 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1034 screen -dmS ipfire $0 batch --background
1035 evaluate 1
1036 exit 0
1037 fi
1038 ;;
1039 watch)
1040 watch_screen
1041 ;;
1042 pxe)
1043 case "$2" in
1044 start)
1045 start_tftpd
1046 ;;
1047 stop)
1048 stop_tftpd
1049 ;;
1050 reload|restart)
1051 reload_tftpd
1052 ;;
1053 esac
1054 exit 0
1055 ;;
1056 lang)
1057 update_langs
1058 ;;
1059 packages)
1060 case "$2" in
1061 sign)
1062 sign_packages
1063 ;;
1064 esac
1065 ;;
1066 "")
1067 clear
1068 svn info
1069 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1070 do
1071 case $name in
1072 "IPFIRE: Downloadsrc")
1073 $0 downloadsrc
1074 ;;
1075 "IPFIRE: Build (silent)")
1076 $0 build-silent
1077 ;;
1078 "IPFIRE: Watch Build")
1079 $0 watch
1080 ;;
1081 "IPFIRE: Batch")
1082 $0 batch
1083 ;;
1084 "IPFIRE: Clean")
1085 $0 clean
1086 ;;
1087 "SVN: Update")
1088 $0 svn update
1089 ;;
1090 "Help")
1091 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1092 cat doc/make.sh-usage
1093 ;;
1094 "LOG: Tail")
1095 tail -f log/_*
1096 ;;
1097 "Exit")
1098 break
1099 ;;
1100 esac
1101 done
1102 ;;
1103 config)
1104 make_config
1105 ;;
1106 *)
1107 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1108 cat doc/make.sh-usage
1109 ;;
1110 esac